# copyright: Huynh Duong Phuong Vi
# www.sketchupforyou.com
module S4U
	module S4u_copy_follow_objects
		class Copy_follow_objects
			def initialize(mode=0)
				@cursor_id = nil
				cursor_path = File.join(File.dirname(__FILE__),(IS_OSX ? "icon_mouse.pdf" : "icon_mouse.svg"))
				@cursor_id = UI.create_cursor(cursor_path, 0, 0) if cursor_path
				@cursor_id_copy = nil
				cursor_path = File.join(File.dirname(__FILE__),(IS_OSX ? "icon_mouse_copy_follow_objects.pdf" : "icon_mouse_copy_follow_objects.svg"))
				@cursor_id_copy = UI.create_cursor(cursor_path, 0, 0) if cursor_path
				@mode=mode
			end
			def activate()
				model=Sketchup.active_model
				ents=model.active_entities
				sel=model.selection
				@elements=[]
				@components=[]
				@components=sel.select{|e| e.is_a?(Sketchup::ComponentInstance) || e.is_a?(Sketchup::Group) }
				if @components.empty? && @mode==0
					UI.messagebox(Strings["Select Groups or Components to Follow"])
					Sketchup.active_model.select_tool nil
				end
				setstatus()
			end
			def onSetCursor
				if @elements.length==0
					UI.set_cursor(@cursor_id) if @cursor_id
				else
					UI.set_cursor(@cursor_id_copy) if @cursor_id_copy
				end
			end
			def onLButtonUp(flags, x, y, view)
				ph = view.pick_helper
				ph.do_pick x,y
				ip = view.inputpoint x, y

				entity = ph.best_picked

				if @elements.length<=1
					if entity.is_a?(Sketchup::ComponentInstance) ||entity.is_a?(Sketchup::Group)
						@elements<<entity
					end
				end
				if @elements.length==2
					copy_follow(@components,@elements.to_a)
					Sketchup.active_model.select_tool nil
				end

			end
			def onMouseMove(flags, x, y, view)
				ph = view.pick_helper
				ph.do_pick x,y
				entity = ph.best_picked
				name=""
				definition=nil
				if entity.is_a?(Sketchup::ComponentInstance) || entity.is_a?(Sketchup::Group)
					name += entity.name.length==0 ? "" : Strings["Name: "]  + entity.name + " - "
					definition = entity.is_a?(Sketchup::ComponentInstance) ? entity.definition : entity.entities[0].parent
				end
				ip = view.inputpoint x, y
				e=ip.face || ip.edge
				definition = e.parent if !definition && e && e.parent.is_a?(Sketchup::ComponentDefinition) && e.parent
				if definition
					s =(definition.group? ? Strings["Group"] : Strings["Component"]) + " - "  + name  +  Strings["Definition: "]  + definition.name
					view.tooltip = s
					setstatus s
					view.invalidate
				end
			end
			def setstatus(text="")
				if @elements.length<1
					s=Strings["Select Group or Component for Copy: "] + text
				else
					s=Strings["Select Group or Component for Reference: "] + text
				end
				Sketchup::set_status_text s
			end
			def resume(view)
				setstatus()
			end
			def copy_follow(comps,elements)
				model = Sketchup.active_model
				entities = model.active_entities
				model.start_operation Strings.GetString(TOOL),true,false,false
				begin
					if @mode==0
						comps.each{|e|
							entities.add_instance elements[0].definition,e.transformation*elements[1].transformation.inverse*elements[0].transformation}
					else
						comps<<elements[1] if comps.empty?
						defns=comps.collect{|e| e.definition}.uniq
						defns.each{|d|
							(d.instances-[elements[1]]).each{|e|
								e.parent.entities.add_instance elements[0].definition,e.transformation*elements[1].transformation.inverse*elements[0].transformation
							}
						}

					end
				model.commit_operation
				rescue=> error
				p error
				p error.backtrace.join("\n")
				model.abort_operation
				end
			end
		end
		def self.main(mode=0)
			Sketchup.active_model.select_tool S4U::S4u_copy_follow_objects::Copy_follow_objects.new(mode)

		end
	end
end